//Guided Missile - it fires bots that are cloaked to look like missiles. You control the bot.
//Created by Aloshi.
//Remade 1/1/2012

datablock AudioProfile(CBStart)
{
	filename = "./SB_cruise_start.WAV";
	description = AudioClosest3d;
	preload = false;
};

datablock AudioProfile(RLoop)
{
	filename = "./SB_cruise_nav_loop.WAV";
	description = AudioClosest3d;
	preload = false;
    isLooping = true;
};

datablock AudioProfile(ExplodeCB)
{
	filename = "./SB_cruise_hit.WAV";
	description = AudioClosest3d;
	preload = false;
};

datablock ExplosionData(cbExplosion)
{
   //explosionShape = "";
   explosionShape = "add-ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
   soundProfile = ExplodeCB;

   lifeTimeMS = 1500;

   particleEmitter = rocketExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = rocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "25 25 25";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 25;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 25;
   radiusDamage = 75;

   impulseRadius = 35;
   impulseForce = 5000;
};

//AddDamageType("cbDirect",   '<bitmap:add-ons/ci/rocket> %1',    '%2 <bitmap:add-ons/ci/rocket> %1',1,1);
//AddDamageType("cbRadius",   '<bitmap:add-ons/ci/rocketRadius> %1',    '%2 <bitmap:add-ons/ci/rocketRadius> %1',1,0);
datablock ProjectileData(cbLauncherProjectile)
{
   projectileShapeName = "add-ons/Weapon_Rocket_Launcher/RocketProjectile.dts";
   directDamage        = 30;
   directDamageType = $DamageType::rocketDirect;
   radiusDamageType = $DamageType::rocketRadius;
   impactImpulse     = 1000;
   verticalImpulse      = 1000;
   explosion           = rocketExplosion;
   particleEmitter     = rocketTrailEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = RLoop;

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";
};

//////////
// item //
//////////
datablock ItemData(cbLauncherItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./wand.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Cruise Bubble";
   iconName = "add-ons/Weapon_Rocket_Launcher/icon_rocketLauncher";
   doColorShift = true;
   colorShiftColor = "0.500 0.100 0.250 1.000";

    // Dynamic properties defined by the scripts
   image = cbLauncherImage;
   canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(cbLauncherImage)
{
   // Basic Item properties
   shapeFile = "./wand.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
//   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = cbLauncherItem;
   ammo = " ";
   projectile = cbLauncherProjectile;
   projectileType = Projectile;

   //casing = rocketLauncherShellDebris;
   shellExitDir        = "1.0 -1.3 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 15.0;   
   shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 5000;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = cbLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.1;
   stateTransitionOnTimeout[0]       = "Ready";
  //stateSound[0]              = RLoop;

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";
   stateAllowImageChange[1]         = true;
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
   stateSequence[1]  = "Ready";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Smoke";
   stateTimeoutValue[2]            = 0.1;
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateSequence[2]                = "Fire";
   stateScript[2]                  = "onFire";
   stateWaitForTimeout[2]        = true;
   stateEmitter[2]               = rocketLauncherFlashEmitter;
   stateEmitterTime[2]           = 0.05;
   stateEmitterNode[2]           = tailNode;
   stateSound[2]              = CBStart;
   stateSequence[2]                = "Fire";
   //stateEjectShell[2]       = true;

   stateName[3] = "Smoke";
   stateEmitter[3]               = rocketLauncherSmokeEmitter;
   stateEmitterTime[3]           = 0.05;
   stateEmitterNode[3]           = "muzzleNode";
   stateTimeoutValue[3]            = 0.1;
   stateSequence[3]                = "TrigDown";
    stateSound[3] = RLoop;
    stateTransitionOnTimeout[3]     = "CoolDown";

   stateName[5] = "CoolDown";
   stateTimeoutValue[5]            = 5;
   stateTransitionOnTimeout[5]     = "Reload";
   stateSequence[5]                = "TrigDown";

   stateName[4]         = "Reload";
   stateTransitionOnTriggerUp[4]     = "Ready";
   stateSequence[4]  = "TrigDown";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";

};

function cbLauncherImage::onFire(%this, %obj, %slot)
{
	//cooldown cheatery prevention
	if(%obj.lastcbRocketFireTime != 0 && getSimTime() - %obj.lastcbRocketFireTime < 5000) //5s
		return;
	
	%obj.lastcbFireTime = getSimTime();
	
	%pos = %obj.getTransform();
	%forvec = %obj.getForwardVector();
	%pos = VectorAdd(%pos, vectorScale(%forvec, 2));
	
	%allrot = %obj.getTransform();
	%rot = getWords(%obj.getTransform(), 3, 6);
	
	%bot = new AIPlayer() 
	{
		datablock="MissileBot";
	};
	clearAllPlayerNodes(%bot); //Makes the bot invisible
	%bot.mountImage(missileimage, 2); //Mounts a missile so it looks like its a missile
	%obj.client.setControlObject(%bot); //Control the missile
	%bot.setTransform(%pos SPC %rot); //Reset the rotation
	
	%bot.owner = %obj.client; //Set owner to you
	%obj.client.bot = %bot; //Set your bot to the bot
	pushBotToPos(%bot); //Start the missile-pushing
    schedule(5000,0, peepeepoopoo,%bot);

}

    function peepeepoopoo(%bot)
{
    MissileExplode(%bot.getPosition(), %bot.owner);
    %bot.schedule(100, delete);
    %bot.owner.setcontrolobject(%bot.owner.player);
}

function pushbottopos(%bot)
{
	if (!isObject(%bot))
		return;
	
	if(isEventPending(%bot.pbtoTick))
		cancel(%bot.pbtoTick);
	
	//If the owner dies while flying the missile
	if(!isObject(%bot.owner.player))
	{
		MissileExplode(%bot.getPosition(), %bot.owner);
		%bot.schedule(100, delete);
		%bot.owner.setcontrolobject(%bot.owner.player); //Switches control to you again
		return;
	}
	
	%ppos = %bot.getEyeVector();
	%vec = %ppos;
	%vec = VectorNormalize(%vec);
	%vec = VectorScale(%vec, 45);
	%bot.setVelocity(%vec);
	%bot.pbtoTick = schedule(100, 0, "pushbottopos", %bot);
}

function ServerCmdSelfDestruct(%client)
{
	%bot.schedule(100, delete);
	%client.setControlObject(%client.player); //Switches control to you again
}

//Another datablock, same as nojet player, made so I can change its onimpact.
datablock PlayerData(MissileBot : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	showEnergyBar = false;
	minImpactSpeed = 2;
	
	uiName = ""; //this shouldn't show in the UI
};

function MissileBot::onImpact(%this, %obj, %collidedObject, %vec, %vecLen)
{
	%obj.owner.player.setwhiteout(0.55);
	MissileExplode(%obj.getPosition(), %obj.owner);
		
	%obj.owner.setcontrolobject(%obj.owner.player); //Switches control back to you
	%obj.schedule(100, delete);
}

datablock ShapeBaseImageData(MissileImage)
{
   // Basic Item properties
   shapeFile = "./KapMissile.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 2;
   offset = "0 0 0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0 0 0";
   eyeRotation = eulerToMatrix("0 0 0");

   doColorShift = false;
   colorShiftColor = MissileItem.colorShiftColor;
   

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "ToolImage";

   // Projectile && Ammo.
   item = MissileItem;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = false;
   //colorShiftColor = MissileItem.colorShiftColor; //"0.200 0.200 0.200 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
};

function clearAllPlayerNodes(%player)
{
	if(!isObject(%player))
		return;
	
	%player.hideNode("headSkin");
	%player.hideNode("LSki");
	%player.hideNode("RSki");
	%player.hideNode("skirtTrimLeft");
	%player.hideNode("skirtTrimRight");
	
	for (%i = 0; $accent[%i] !$= ""; %i++) %player.hideNode($accent[%i]);
	for (%i = 0; $chest[%i] !$= ""; %i++) %player.hideNode($chest[%i]);
	for (%i = 0; $hat[%i] !$= ""; %i++) %player.hideNode($hat[%i]);
	for (%i = 0; $hip[%i] !$= ""; %i++) %player.hideNode($hip[%i]);
	for (%i = 0; $LArm[%i] !$= ""; %i++) %player.hideNode($LArm[%i]);
	for (%i = 0; $LHand[%i] !$= ""; %i++) %player.hideNode($LHand[%i]);
	for (%i = 0; $LLeg[%i] !$= ""; %i++) %player.hideNode($LLeg[%i]);
	for (%i = 0; $pack[%i] !$= ""; %i++) %player.hideNode($pack[%i]);
	for (%i = 0; $RArm[%i] !$= ""; %i++) %player.hideNode($RArm[%i]);
	for (%i = 0; $RHand[%i] !$= ""; %i++) %player.hideNode($RHand[%i]);
	for (%i = 0; $RLeg[%i] !$= ""; %i++) %player.hideNode($RLeg[%i]);
	for (%i = 0; $secondPack[%i] !$= ""; %i++) %player.hideNode($secondPack[%i]);
}

datablock ProjectileData(MissileExplosionProjectile)
{
 //projectileShapeName = "./shapes/RocketProjectile.dts";
   directDamage        = 700;
   directDamageType    = $DamageType::RocketDirect;
   radiusDamage        = 5000;
   damageRadius        = 1500;
   radiusDamageType    = $DamageType::RocketRadius;
   muzzleVelocity      = 0.1;
   velInheritFactor    = 1;
   armingDelay         = 0;
   lifetime            = 500;
   fadeDelay           = 490;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 1.0;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   brickExplosionRadius = 6;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;
   
   explosion           = cbExplosion;
   //particleEmitter     = rocketTrailEmitter;
};

function MissileExplode(%pos, %sourceClient)
{
	%projectile = new Projectile()
	{
		dataBlock        = "MissileExplosionProjectile";
		initialPosition  = %pos;
		initialVelocity  = "0 0 0";
		sourceObject     = %sourceClient.player;
		sourceClient 		 = %sourceClient;
		sourceSlot			 = %slot;
		client 					 = %sourceClient;
	};
	missionCleanup.add(%projectile);
	%projectile.explode();
}
